#include "Copyright.h"
#include "Buffer.h"



BBuffer::BBuffer (int width, int height) :
    m_width    (width),
    m_height   (height),
    m_data     (new BBYTE [width * height]),
    m_rowindex (new BBYTE * [height]) {

    BASSERT (width % 4 == 0);

    if (IsTopdown ())
        for (int row=0; row<height; row++)
            m_rowindex [row] = m_data + row * width;
    else
        for (int row=0; row<height; row++)
            m_rowindex [row] = m_data + (height-1-row) * width;
}



BBuffer::~BBuffer () {
    delete [] m_rowindex;
    delete [] m_data;
    return;
}


